#pragma once
#if MIRAGE_PLATFORM_WINDOWS
#include <Windows.h>
#include <ShellScalingApi.h>
#pragma comment(lib, "Shcore.lib")
#endif

#include <spdlog/spdlog.h>

namespace mirage {
    class dpi_sensibility {
    public:

        static void init_dpi_sensibility() {
            dpi_sensibility_impl();
        }
    private:
#if MIRAGE_PLATFORM_WINDOWS
        static void dpi_sensibility_impl() {
            if (SetProcessDpiAwareness(PROCESS_PER_MONITOR_DPI_AWARE)) {
                spdlog::info("设置DPI感知上下文成功");
            }
        }
#else
        static void dpi_sensibility_impl() {
            spdlog::warn("当前平台不支持DPI感知");
        }
#endif
    };
}
