#include "window/window.h"

namespace mirage {
    class mobile_window_event_listener : public LLGL::Canvas::EventListener {
    public:
        virtual void OnQuit(LLGL::Canvas& sender, bool& veto) override {
            auto wrapper = static_cast<window*>(sender.GetUserData());
            wrapper->on_quit(veto);
        }
//        virtual void OnInit(LLGL::Canvas& sender) override {
//            auto wrapper = static_cast<window*>(sender.GetUserData());
//            wrapper->on_init();
//        }
//        virtual void OnDestroy(LLGL::Canvas& sender) override {
//            auto wrapper = static_cast<window*>(sender.GetUserData());
//            wrapper->on_destroy();
//        }
//        virtual void OnDraw(LLGL::Canvas& sender) override {
//            auto wrapper = static_cast<window*>(sender.GetUserData());
//            wrapper->on_draw();
//        }
        virtual void OnResize(LLGL::Canvas& sender, const LLGL::Extent2D& clientAreaSize) override {
            auto wrapper = static_cast<window*>(sender.GetUserData());
            wrapper->on_resize(clientAreaSize);
        }
        virtual void OnTapGesture(LLGL::Canvas& sender, const LLGL::Offset2D& position, std::uint32_t numTouches) override {
            auto wrapper = static_cast<window*>(sender.GetUserData());
            wrapper->on_tap_gesture(position, numTouches);
        }
        virtual void OnPanGesture(LLGL::Canvas& sender, const LLGL::Offset2D& position, std::uint32_t numTouches, float dx, float dy, LLGL::EventAction action) override {
            auto wrapper = static_cast<window*>(sender.GetUserData());
            wrapper->on_pan_gesture(position, numTouches, dx, dy, action);
        }
        virtual void OnKeyDown(LLGL::Canvas& sender, LLGL::Key keyCode) override {
            auto wrapper = static_cast<window*>(sender.GetUserData());
            wrapper->on_key_down(keyCode);
        }
        virtual void OnKeyUp(LLGL::Canvas& sender, LLGL::Key keyCode) override {
            auto wrapper = static_cast<window*>(sender.GetUserData());
            wrapper->on_key_up(keyCode);
        }
    };
    void window::show(bool in_show) {
    }
    void window::move(const LLGL::Offset2D& position) {
    }

    void window::move_delta(const LLGL::Offset2D& delta) {
    }

    void window::resize(const LLGL::Extent2D& size) {
    }

    LLGL::Extent2D window::get_size() const {
        if (const auto canvas_ptr = static_cast<LLGL::Canvas*>(surface.get())) {
            return canvas_ptr->FindResidentDisplay()->GetDisplayMode().resolution;
        }
        return {};
    }

    void window::init_event_listener() {
        if (auto canvas_ptr = static_cast<LLGL::Canvas*>(surface.get())) {
            canvas_ptr->SetUserData(this);
            canvas_ptr->AddEventListener(std::make_shared<mobile_window_event_listener>());
        }
    }
}
