#include "window.h"

#if MIRAGE_PLATFORM_MACOS
#include "LLGL/Platform/MacOS/MacOSNativeHandle.h"
#elif MIRAGE_PLATFORM_IOS
#include "LLGL/Platform/iOS/iOSNativeHandle.h"
#endif

namespace mirage {
    void* window::get_native_handle() const {
        LLGL::NativeHandle native_handle{};
        if (surface->GetNativeHandle(&native_handle, sizeof(native_handle))) {
#if MIRAGE_PLATFORM_MACOS
            return native_handle.responder;
#elif MIRAGE_PLATFORM_IOS
            return native_handle.view;
#endif
        }
        return nullptr;
    }
}
